[CentOS 5] Apache 2.4.2 컴파일 설치방법

Published on: 2013.11.14 13:11 by krespo
아파치 서버를 설치하기 전 먼저 아파치를 컴파일 하여 설치하기 위한 라이브러리를 먼저 설치해 줘야 합니다. 1. gcc 컴파일러, pcre 설치
# yum install gcc
# yum install pcre-devel
2. APR, APR-Util 설치 위와같이 yum을 통해 간단하게 APR을 설치할 수 있지만 yum으로 설치되는 APR의 버전이 너무 낮아 Apache 2.4를 설치할때 에러를 내면서 설치가 되지 않는다. 그러므로 홈페이지에서 최신버전을 다운로드 받아 컴파일 설치하는 방식으로 진행 해야 합니다.
## APR설치
## APR의 경로를 설정하지 않으면 기본적으로 /usr/local/apr 에 설치됩니다.
$ wget http://mirror.apache-kr.org//apr/apr-1.4.6.tar.gz
$ gzip -d apr-1.4.6.tar.gz
$ tar xvf apr-1.4.6.tar.gz
$ cd apr-1.4.6
$ su
# ./configure; make && make install
## APR-Util
$ wget http://apache.mirror.cdnetworks.com//apr/apr-util-1.4.1.tar.gz
$ gzip -d apr-util-1.4.1.tar.gz
$ tar xvf apr-util-1.4.1.tar
$ cd apr-util-1.4.1
$ su
## configure 옵션중 with-apr 로 위에서 설치한 apr의 경로를 지정해 줍니다.
# ./configure --with-apr=/usr/local/apr ;make && make install
설치시 유의사항이 있다면 반드시 APR먼저 설치한 뒤 APR-util을 설치해야 합니다. 3. Apache 2.4.2 설치
$ mkdir ${사용자 디렉토리}/httpd-2.4.2
$ wget http://apache.mirror.cdnetworks.com//httpd/httpd-2.4.2.tar.gz
$ tar xvfz httpd-2.4.2.tar
$ cd httpd-2.4.2
$ su
## with-apr 설치 옵션으로 위에서 설치한 apr의 설치 경로를 입력합니다.
# ./configure --prefix=${아파치 설치 경로} --with-apr=/usr/local/apr ; make && make install
설치 중 다음과 같은 에러가 발생할 수 있습니다.
exports.c:2858: error: redefinition of 'ap_hack_apr_xlate_conv_byte'
exports.c:1813: error: previous definition of 'ap_hack_apr_xlate_conv_byte' was here
exports.c:2859: error: redefinition of 'ap_hack_apr_xlate_close'
exports.c:1814: error: previous definition of 'ap_hack_apr_xlate_close' was here
exports.c:2864: error: redefinition of 'ap_hack_apr_text_append'
exports.c:1819: error: previous definition of 'ap_hack_apr_text_append' was here
exports.c:2865: error: redefinition of 'ap_hack_apr_xml_parser_create'
exports.c:1820: error: previous definition of 'ap_hack_apr_xml_parser_create' was here
exports.c:2866: error: redefinition of 'ap_hack_apr_xml_parse_file'
exports.c:1821: error: previous definition of 'ap_hack_apr_xml_parse_file' was here
exports.c:2867: error: redefinition of 'ap_hack_apr_xml_parser_feed'
exports.c:1822: error: previous definition of 'ap_hack_apr_xml_parser_feed' was here
exports.c:2868: error: redefinition of 'ap_hack_apr_xml_parser_done'
exports.c:1823: error: previous definition of 'ap_hack_apr_xml_parser_done' was here
exports.c:2869: error: redefinition of 'ap_hack_apr_xml_parser_geterror'
exports.c:1824: error: previous definition of 'ap_hack_apr_xml_parser_geterror' was here
exports.c:2870: error: redefinition of 'ap_hack_apr_xml_to_text'
exports.c:1825: error: previous definition of 'ap_hack_apr_xml_to_text' was here
exports.c:2871: error: redefinition of 'ap_hack_apr_xml_empty_elem'
exports.c:1826: error: previous definition of 'ap_hack_apr_xml_empty_elem' was here
exports.c:2872: error: redefinition of 'ap_hack_apr_xml_quote_string'
exports.c:1827: error: previous definition of 'ap_hack_apr_xml_quote_string' was here
exports.c:2873: error: redefinition of 'ap_hack_apr_xml_quote_elem'
exports.c:1828: error: previous definition of 'ap_hack_apr_xml_quote_elem' was here
exports.c:2874: error: redefinition of 'ap_hack_apr_xml_insert_uri'
exports.c:1829: error: previous definition of 'ap_hack_apr_xml_insert_uri' was here
exports.c:2883: error: redefinition of 'ap_hack_apu_version'
exports.c:1838: error: previous definition of 'ap_hack_apu_version' was here
exports.c:2884: error: redefinition of 'ap_hack_apu_version_string'
exports.c:1839: error: previous definition of 'ap_hack_apu_version_string' was here
make[2]: *** [exports.lo] 오류 1
make[2]: Leaving directory `/home/${사용자}/httpd-2.4.2/server'
make[1]: *** [all-recursive] 오류 1
make[1]: Leaving directory `/home/${사용자}/httpd-2.4.2/server'
make: *** [all-recursive] 오류 1
이 에러는 yum으로 낮은 버전의 APR을 설치한 후 다시 컴파일 설치로 최신버전의 APR이 설치되었을때 발생하는 문제로 낮은 버전의 APM을 지우면 됩니다.
#yum remove APR
Name
Password
Homepage
Secret